> ## Documentation Index
> Fetch the complete documentation index at: https://www.activepieces.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Apply Flow Operation

> Apply an operation to a flow



## OpenAPI

````yaml POST /v1/flows/{id}
openapi: 3.1.0
info:
  title: Activepieces Documentation
  version: 0.0.0
servers:
  - url: https://cloud.activepieces.com/api
    description: Production Server
security: []
externalDocs:
  url: https://www.activepieces.com/docs
  description: Find more info here
paths:
  /v1/flows/{id}:
    post:
      tags:
        - flows
      description: Apply an operation to a flow
      parameters:
        - schema:
            type: string
            pattern: ^[0-9a-zA-Z]{21}$
          in: path
          name: id
          required: true
      requestBody:
        content:
          application/json:
            schema:
              anyOf:
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - MOVE_ACTION
                    request:
                      type: object
                      properties:
                        name:
                          type: string
                        newParentStep:
                          type: string
                        stepLocationRelativeToNewParent:
                          type: string
                          enum:
                            - AFTER
                            - INSIDE_LOOP
                            - INSIDE_BRANCH
                        branchIndex:
                          type: number
                      required:
                        - name
                        - newParentStep
                  required:
                    - type
                    - request
                  description: Move Action
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - CHANGE_STATUS
                    request:
                      type: object
                      properties:
                        status:
                          type: string
                          enum:
                            - ENABLED
                            - DISABLED
                      required:
                        - status
                  required:
                    - type
                    - request
                  description: Change Status
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - LOCK_AND_PUBLISH
                    request:
                      type: object
                      properties:
                        status:
                          type: string
                          enum:
                            - ENABLED
                            - DISABLED
                  required:
                    - type
                    - request
                  description: Lock and Publish
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - USE_AS_DRAFT
                    request:
                      type: object
                      properties:
                        versionId:
                          type: string
                      required:
                        - versionId
                  required:
                    - type
                    - request
                  description: Copy as Draft
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - LOCK_FLOW
                    request:
                      type: object
                      properties: {}
                  required:
                    - type
                    - request
                  description: Lock Flow
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - IMPORT_FLOW
                    request:
                      type: object
                      properties:
                        displayName:
                          type: string
                        trigger:
                          anyOf:
                            - type: object
                              properties:
                                name:
                                  type: string
                                  pattern: ^[a-zA-Z_][a-zA-Z0-9_]*$
                                valid:
                                  type: boolean
                                displayName:
                                  type: string
                                nextAction: {}
                                lastUpdatedDate:
                                  type: string
                                type:
                                  type: string
                                  enum:
                                    - PIECE_TRIGGER
                                settings:
                                  type: object
                                  properties:
                                    sampleData:
                                      type: object
                                      properties:
                                        sampleDataFileId:
                                          type: string
                                        sampleDataInputFileId:
                                          type: string
                                        lastTestDate:
                                          type: string
                                    propertySettings:
                                      type: object
                                      propertyNames:
                                        type: string
                                      additionalProperties:
                                        type: object
                                        properties:
                                          type:
                                            type: string
                                            enum:
                                              - MANUAL
                                              - DYNAMIC
                                          schema: {}
                                        required:
                                          - type
                                    customLogoUrl:
                                      type: string
                                    pieceName:
                                      type: string
                                    pieceVersion:
                                      type: string
                                      pattern: ^([~^])?[0-9]+\.[0-9]+\.[0-9]+$
                                    triggerName:
                                      type: string
                                    input:
                                      type: object
                                      propertyNames:
                                        type: string
                                      additionalProperties: {}
                                  required:
                                    - propertySettings
                                    - pieceName
                                    - pieceVersion
                                    - input
                              required:
                                - name
                                - valid
                                - displayName
                                - lastUpdatedDate
                                - type
                                - settings
                            - type: object
                              properties:
                                name:
                                  type: string
                                  pattern: ^[a-zA-Z_][a-zA-Z0-9_]*$
                                valid:
                                  type: boolean
                                displayName:
                                  type: string
                                nextAction: {}
                                lastUpdatedDate:
                                  type: string
                                type:
                                  type: string
                                  enum:
                                    - EMPTY
                                settings: {}
                              required:
                                - name
                                - valid
                                - displayName
                                - lastUpdatedDate
                                - type
                                - settings
                        schemaVersion:
                          anyOf:
                            - type: string
                            - type: 'null'
                        notes:
                          anyOf:
                            - type: array
                              items:
                                type: object
                                properties:
                                  id:
                                    type: string
                                  content:
                                    type: string
                                  ownerId:
                                    anyOf:
                                      - type: string
                                      - type: 'null'
                                  color:
                                    type: string
                                    enum:
                                      - orange
                                      - red
                                      - green
                                      - blue
                                      - purple
                                      - yellow
                                  position:
                                    type: object
                                    properties:
                                      x:
                                        type: number
                                      'y':
                                        type: number
                                    required:
                                      - x
                                      - 'y'
                                  size:
                                    type: object
                                    properties:
                                      width:
                                        type: number
                                      height:
                                        type: number
                                    required:
                                      - width
                                      - height
                                  createdAt:
                                    type: string
                                  updatedAt:
                                    type: string
                                required:
                                  - id
                                  - content
                                  - color
                                  - position
                                  - size
                                  - createdAt
                                  - updatedAt
                            - type: 'null'
                      required:
                        - displayName
                        - trigger
                  required:
                    - type
                    - request
                  description: Import Flow
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - CHANGE_NAME
                    request:
                      type: object
                      properties:
                        displayName:
                          type: string
                      required:
                        - displayName
                  required:
                    - type
                    - request
                  description: Change Name
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - DELETE_ACTION
                    request:
                      type: object
                      properties:
                        names:
                          type: array
                          items:
                            type: string
                      required:
                        - names
                  required:
                    - type
                    - request
                  description: Delete Action
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - UPDATE_ACTION
                    request:
                      anyOf:
                        - allOf:
                            - type: object
                              properties:
                                name:
                                  type: string
                                  pattern: ^[a-zA-Z_][a-zA-Z0-9_]*$
                                valid:
                                  type: boolean
                                displayName:
                                  type: string
                                skip:
                                  type: boolean
                                type:
                                  type: string
                                  enum:
                                    - CODE
                              required:
                                - name
                                - valid
                                - displayName
                                - type
                            - type: object
                              properties:
                                settings:
                                  type: object
                                  properties:
                                    customLogoUrl:
                                      type: string
                                    sourceCode:
                                      type: object
                                      properties:
                                        packageJson:
                                          type: string
                                        code:
                                          type: string
                                      required:
                                        - packageJson
                                        - code
                                    input:
                                      type: object
                                      propertyNames:
                                        type: string
                                      additionalProperties: {}
                                    errorHandlingOptions:
                                      type: object
                                      properties:
                                        continueOnFailure:
                                          type: object
                                          properties:
                                            value:
                                              type: boolean
                                        retryOnFailure:
                                          type: object
                                          properties:
                                            value:
                                              type: boolean
                                  required:
                                    - sourceCode
                                    - input
                              required:
                                - settings
                        - allOf:
                            - type: object
                              properties:
                                name:
                                  type: string
                                  pattern: ^[a-zA-Z_][a-zA-Z0-9_]*$
                                valid:
                                  type: boolean
                                displayName:
                                  type: string
                                skip:
                                  type: boolean
                                type:
                                  type: string
                                  enum:
                                    - LOOP_ON_ITEMS
                              required:
                                - name
                                - valid
                                - displayName
                                - type
                            - type: object
                              properties:
                                settings:
                                  type: object
                                  properties:
                                    customLogoUrl:
                                      type: string
                                    items:
                                      type: string
                                  required:
                                    - items
                              required:
                                - settings
                        - allOf:
                            - type: object
                              properties:
                                name:
                                  type: string
                                  pattern: ^[a-zA-Z_][a-zA-Z0-9_]*$
                                valid:
                                  type: boolean
                                displayName:
                                  type: string
                                skip:
                                  type: boolean
                                type:
                                  type: string
                                  enum:
                                    - PIECE
                              required:
                                - name
                                - valid
                                - displayName
                                - type
                            - type: object
                              properties:
                                settings:
                                  type: object
                                  properties:
                                    customLogoUrl:
                                      type: string
                                    propertySettings:
                                      type: object
                                      propertyNames:
                                        type: string
                                      additionalProperties:
                                        type: object
                                        properties:
                                          type:
                                            type: string
                                            enum:
                                              - MANUAL
                                              - DYNAMIC
                                          schema: {}
                                        required:
                                          - type
                                    pieceName:
                                      type: string
                                    pieceVersion:
                                      type: string
                                      pattern: ^([~^])?[0-9]+\.[0-9]+\.[0-9]+$
                                    actionName:
                                      type: string
                                    input:
                                      type: object
                                      propertyNames:
                                        type: string
                                      additionalProperties: {}
                                    errorHandlingOptions:
                                      type: object
                                      properties:
                                        continueOnFailure:
                                          type: object
                                          properties:
                                            value:
                                              type: boolean
                                        retryOnFailure:
                                          type: object
                                          properties:
                                            value:
                                              type: boolean
                                  required:
                                    - propertySettings
                                    - pieceName
                                    - pieceVersion
                                    - input
                              required:
                                - settings
                        - allOf:
                            - type: object
                              properties:
                                name:
                                  type: string
                                  pattern: ^[a-zA-Z_][a-zA-Z0-9_]*$
                                valid:
                                  type: boolean
                                displayName:
                                  type: string
                                skip:
                                  type: boolean
                                type:
                                  type: string
                                  enum:
                                    - ROUTER
                              required:
                                - name
                                - valid
                                - displayName
                                - type
                            - type: object
                              properties:
                                settings:
                                  type: object
                                  properties:
                                    customLogoUrl:
                                      type: string
                                    branches:
                                      type: array
                                      items:
                                        anyOf:
                                          - type: object
                                            properties:
                                              conditions:
                                                type: array
                                                items:
                                                  type: array
                                                  items:
                                                    anyOf:
                                                      - type: object
                                                        properties:
                                                          firstValue:
                                                            type: string
                                                          secondValue:
                                                            type: string
                                                          caseSensitive:
                                                            type: boolean
                                                          operator:
                                                            anyOf:
                                                              - type: string
                                                                enum:
                                                                  - TEXT_CONTAINS
                                                              - type: string
                                                                enum:
                                                                  - TEXT_DOES_NOT_CONTAIN
                                                              - type: string
                                                                enum:
                                                                  - TEXT_EXACTLY_MATCHES
                                                              - type: string
                                                                enum:
                                                                  - TEXT_DOES_NOT_EXACTLY_MATCH
                                                              - type: string
                                                                enum:
                                                                  - TEXT_START_WITH
                                                              - type: string
                                                                enum:
                                                                  - TEXT_DOES_NOT_START_WITH
                                                              - type: string
                                                                enum:
                                                                  - TEXT_ENDS_WITH
                                                              - type: string
                                                                enum:
                                                                  - TEXT_DOES_NOT_END_WITH
                                                              - type: string
                                                                enum:
                                                                  - LIST_CONTAINS
                                                              - type: string
                                                                enum:
                                                                  - LIST_DOES_NOT_CONTAIN
                                                        required:
                                                          - firstValue
                                                          - secondValue
                                                      - type: object
                                                        properties:
                                                          firstValue:
                                                            type: string
                                                          secondValue:
                                                            type: string
                                                          operator:
                                                            anyOf:
                                                              - type: string
                                                                enum:
                                                                  - NUMBER_IS_GREATER_THAN
                                                              - type: string
                                                                enum:
                                                                  - NUMBER_IS_LESS_THAN
                                                              - type: string
                                                                enum:
                                                                  - NUMBER_IS_EQUAL_TO
                                                        required:
                                                          - firstValue
                                                          - secondValue
                                                      - type: object
                                                        properties:
                                                          firstValue:
                                                            type: string
                                                          secondValue:
                                                            type: string
                                                          operator:
                                                            anyOf:
                                                              - type: string
                                                                enum:
                                                                  - DATE_IS_BEFORE
                                                              - type: string
                                                                enum:
                                                                  - DATE_IS_EQUAL
                                                              - type: string
                                                                enum:
                                                                  - DATE_IS_AFTER
                                                        required:
                                                          - firstValue
                                                          - secondValue
                                                      - type: object
                                                        properties:
                                                          firstValue:
                                                            type: string
                                                          operator:
                                                            anyOf:
                                                              - type: string
                                                                enum:
                                                                  - EXISTS
                                                              - type: string
                                                                enum:
                                                                  - DOES_NOT_EXIST
                                                              - type: string
                                                                enum:
                                                                  - BOOLEAN_IS_TRUE
                                                              - type: string
                                                                enum:
                                                                  - BOOLEAN_IS_FALSE
                                                              - type: string
                                                                enum:
                                                                  - LIST_IS_EMPTY
                                                              - type: string
                                                                enum:
                                                                  - LIST_IS_NOT_EMPTY
                                                        required:
                                                          - firstValue
                                              branchType:
                                                type: string
                                                enum:
                                                  - CONDITION
                                              branchName:
                                                type: string
                                            required:
                                              - conditions
                                              - branchType
                                              - branchName
                                          - type: object
                                            properties:
                                              branchType:
                                                type: string
                                                enum:
                                                  - FALLBACK
                                              branchName:
                                                type: string
                                            required:
                                              - branchType
                                              - branchName
                                    executionType:
                                      type: string
                                      enum:
                                        - EXECUTE_ALL_MATCH
                                        - EXECUTE_FIRST_MATCH
                                  required:
                                    - branches
                                    - executionType
                              required:
                                - settings
                  required:
                    - type
                    - request
                  description: Update Action
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - ADD_ACTION
                    request:
                      type: object
                      properties:
                        parentStep:
                          type: string
                        stepLocationRelativeToParent:
                          type: string
                          enum:
                            - AFTER
                            - INSIDE_LOOP
                            - INSIDE_BRANCH
                        branchIndex:
                          type: number
                        action:
                          anyOf:
                            - allOf:
                                - type: object
                                  properties:
                                    name:
                                      type: string
                                      pattern: ^[a-zA-Z_][a-zA-Z0-9_]*$
                                    valid:
                                      type: boolean
                                    displayName:
                                      type: string
                                    skip:
                                      type: boolean
                                    type:
                                      type: string
                                      enum:
                                        - CODE
                                  required:
                                    - name
                                    - valid
                                    - displayName
                                    - type
                                - type: object
                                  properties:
                                    settings:
                                      type: object
                                      properties:
                                        customLogoUrl:
                                          type: string
                                        sourceCode:
                                          type: object
                                          properties:
                                            packageJson:
                                              type: string
                                            code:
                                              type: string
                                          required:
                                            - packageJson
                                            - code
                                        input:
                                          type: object
                                          propertyNames:
                                            type: string
                                          additionalProperties: {}
                                        errorHandlingOptions:
                                          type: object
                                          properties:
                                            continueOnFailure:
                                              type: object
                                              properties:
                                                value:
                                                  type: boolean
                                            retryOnFailure:
                                              type: object
                                              properties:
                                                value:
                                                  type: boolean
                                      required:
                                        - sourceCode
                                        - input
                                  required:
                                    - settings
                            - allOf:
                                - type: object
                                  properties:
                                    name:
                                      type: string
                                      pattern: ^[a-zA-Z_][a-zA-Z0-9_]*$
                                    valid:
                                      type: boolean
                                    displayName:
                                      type: string
                                    skip:
                                      type: boolean
                                    type:
                                      type: string
                                      enum:
                                        - LOOP_ON_ITEMS
                                  required:
                                    - name
                                    - valid
                                    - displayName
                                    - type
                                - type: object
                                  properties:
                                    settings:
                                      type: object
                                      properties:
                                        customLogoUrl:
                                          type: string
                                        items:
                                          type: string
                                      required:
                                        - items
                                  required:
                                    - settings
                            - allOf:
                                - type: object
                                  properties:
                                    name:
                                      type: string
                                      pattern: ^[a-zA-Z_][a-zA-Z0-9_]*$
                                    valid:
                                      type: boolean
                                    displayName:
                                      type: string
                                    skip:
                                      type: boolean
                                    type:
                                      type: string
                                      enum:
                                        - PIECE
                                  required:
                                    - name
                                    - valid
                                    - displayName
                                    - type
                                - type: object
                                  properties:
                                    settings:
                                      type: object
                                      properties:
                                        customLogoUrl:
                                          type: string
                                        propertySettings:
                                          type: object
                                          propertyNames:
                                            type: string
                                          additionalProperties:
                                            type: object
                                            properties:
                                              type:
                                                type: string
                                                enum:
                                                  - MANUAL
                                                  - DYNAMIC
                                              schema: {}
                                            required:
                                              - type
                                        pieceName:
                                          type: string
                                        pieceVersion:
                                          type: string
                                          pattern: ^([~^])?[0-9]+\.[0-9]+\.[0-9]+$
                                        actionName:
                                          type: string
                                        input:
                                          type: object
                                          propertyNames:
                                            type: string
                                          additionalProperties: {}
                                        errorHandlingOptions:
                                          type: object
                                          properties:
                                            continueOnFailure:
                                              type: object
                                              properties:
                                                value:
                                                  type: boolean
                                            retryOnFailure:
                                              type: object
                                              properties:
                                                value:
                                                  type: boolean
                                      required:
                                        - propertySettings
                                        - pieceName
                                        - pieceVersion
                                        - input
                                  required:
                                    - settings
                            - allOf:
                                - type: object
                                  properties:
                                    name:
                                      type: string
                                      pattern: ^[a-zA-Z_][a-zA-Z0-9_]*$
                                    valid:
                                      type: boolean
                                    displayName:
                                      type: string
                                    skip:
                                      type: boolean
                                    type:
                                      type: string
                                      enum:
                                        - ROUTER
                                  required:
                                    - name
                                    - valid
                                    - displayName
                                    - type
                                - type: object
                                  properties:
                                    settings:
                                      type: object
                                      properties:
                                        customLogoUrl:
                                          type: string
                                        branches:
                                          type: array
                                          items:
                                            anyOf:
                                              - type: object
                                                properties:
                                                  conditions:
                                                    type: array
                                                    items:
                                                      type: array
                                                      items:
                                                        anyOf:
                                                          - type: object
                                                            properties:
                                                              firstValue:
                                                                type: string
                                                              secondValue:
                                                                type: string
                                                              caseSensitive:
                                                                type: boolean
                                                              operator:
                                                                anyOf:
                                                                  - type: string
                                                                    enum:
                                                                      - TEXT_CONTAINS
                                                                  - type: string
                                                                    enum:
                                                                      - TEXT_DOES_NOT_CONTAIN
                                                                  - type: string
                                                                    enum:
                                                                      - TEXT_EXACTLY_MATCHES
                                                                  - type: string
                                                                    enum:
                                                                      - TEXT_DOES_NOT_EXACTLY_MATCH
                                                                  - type: string
                                                                    enum:
                                                                      - TEXT_START_WITH
                                                                  - type: string
                                                                    enum:
                                                                      - TEXT_DOES_NOT_START_WITH
                                                                  - type: string
                                                                    enum:
                                                                      - TEXT_ENDS_WITH
                                                                  - type: string
                                                                    enum:
                                                                      - TEXT_DOES_NOT_END_WITH
                                                                  - type: string
                                                                    enum:
                                                                      - LIST_CONTAINS
                                                                  - type: string
                                                                    enum:
                                                                      - LIST_DOES_NOT_CONTAIN
                                                            required:
                                                              - firstValue
                                                              - secondValue
                                                          - type: object
                                                            properties:
                                                              firstValue:
                                                                type: string
                                                              secondValue:
                                                                type: string
                                                              operator:
                                                                anyOf:
                                                                  - type: string
                                                                    enum:
                                                                      - NUMBER_IS_GREATER_THAN
                                                                  - type: string
                                                                    enum:
                                                                      - NUMBER_IS_LESS_THAN
                                                                  - type: string
                                                                    enum:
                                                                      - NUMBER_IS_EQUAL_TO
                                                            required:
                                                              - firstValue
                                                              - secondValue
                                                          - type: object
                                                            properties:
                                                              firstValue:
                                                                type: string
                                                              secondValue:
                                                                type: string
                                                              operator:
                                                                anyOf:
                                                                  - type: string
                                                                    enum:
                                                                      - DATE_IS_BEFORE
                                                                  - type: string
                                                                    enum:
                                                                      - DATE_IS_EQUAL
                                                                  - type: string
                                                                    enum:
                                                                      - DATE_IS_AFTER
                                                            required:
                                                              - firstValue
                                                              - secondValue
                                                          - type: object
                                                            properties:
                                                              firstValue:
                                                                type: string
                                                              operator:
                                                                anyOf:
                                                                  - type: string
                                                                    enum:
                                                                      - EXISTS
                                                                  - type: string
                                                                    enum:
                                                                      - DOES_NOT_EXIST
                                                                  - type: string
                                                                    enum:
                                                                      - BOOLEAN_IS_TRUE
                                                                  - type: string
                                                                    enum:
                                                                      - BOOLEAN_IS_FALSE
                                                                  - type: string
                                                                    enum:
                                                                      - LIST_IS_EMPTY
                                                                  - type: string
                                                                    enum:
                                                                      - LIST_IS_NOT_EMPTY
                                                            required:
                                                              - firstValue
                                                  branchType:
                                                    type: string
                                                    enum:
                                                      - CONDITION
                                                  branchName:
                                                    type: string
                                                required:
                                                  - conditions
                                                  - branchType
                                                  - branchName
                                              - type: object
                                                properties:
                                                  branchType:
                                                    type: string
                                                    enum:
                                                      - FALLBACK
                                                  branchName:
                                                    type: string
                                                required:
                                                  - branchType
                                                  - branchName
                                        executionType:
                                          type: string
                                          enum:
                                            - EXECUTE_ALL_MATCH
                                            - EXECUTE_FIRST_MATCH
                                      required:
                                        - branches
                                        - executionType
                                  required:
                                    - settings
                      required:
                        - parentStep
                        - action
                  required:
                    - type
                    - request
                  description: Add Action
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - UPDATE_TRIGGER
                    request:
                      anyOf:
                        - type: object
                          properties:
                            name:
                              type: string
                              pattern: ^[a-zA-Z_][a-zA-Z0-9_]*$
                            valid:
                              type: boolean
                            displayName:
                              type: string
                            nextAction: {}
                            type:
                              type: string
                              enum:
                                - EMPTY
                            settings: {}
                          required:
                            - name
                            - valid
                            - displayName
                            - type
                            - settings
                        - allOf:
                            - type: object
                              properties:
                                name:
                                  type: string
                                  pattern: ^[a-zA-Z_][a-zA-Z0-9_]*$
                                valid:
                                  type: boolean
                                displayName:
                                  type: string
                                nextAction: {}
                                type:
                                  type: string
                                  enum:
                                    - PIECE_TRIGGER
                              required:
                                - name
                                - valid
                                - displayName
                                - type
                            - type: object
                              properties:
                                settings:
                                  type: object
                                  properties:
                                    propertySettings:
                                      type: object
                                      propertyNames:
                                        type: string
                                      additionalProperties:
                                        type: object
                                        properties:
                                          type:
                                            type: string
                                            enum:
                                              - MANUAL
                                              - DYNAMIC
                                          schema: {}
                                        required:
                                          - type
                                    customLogoUrl:
                                      type: string
                                    pieceName:
                                      type: string
                                    pieceVersion:
                                      type: string
                                      pattern: ^([~^])?[0-9]+\.[0-9]+\.[0-9]+$
                                    triggerName:
                                      type: string
                                    input:
                                      type: object
                                      propertyNames:
                                        type: string
                                      additionalProperties: {}
                                  required:
                                    - propertySettings
                                    - pieceName
                                    - pieceVersion
                                    - input
                              required:
                                - settings
                  required:
                    - type
                    - request
                  description: Update Trigger
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - CHANGE_FOLDER
                    request:
                      type: object
                      properties:
                        folderId:
                          anyOf:
                            - type: string
                            - type: 'null'
                  required:
                    - type
                    - request
                  description: Change Folder
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - DUPLICATE_ACTION
                    request:
                      type: object
                      properties:
                        stepName:
                          type: string
                      required:
                        - stepName
                  required:
                    - type
                    - request
                  description: Duplicate Action
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - DELETE_BRANCH
                    request:
                      type: object
                      properties:
                        branchIndex:
                          type: number
                        stepName:
                          type: string
                      required:
                        - branchIndex
                        - stepName
                  required:
                    - type
                    - request
                  description: Delete Branch
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - ADD_BRANCH
                    request:
                      type: object
                      properties:
                        branchIndex:
                          type: number
                        stepName:
                          type: string
                        conditions:
                          type: array
                          items:
                            type: array
                            items:
                              anyOf:
                                - type: object
                                  properties:
                                    firstValue:
                                      type: string
                                    secondValue:
                                      type: string
                                    caseSensitive:
                                      type: boolean
                                    operator:
                                      anyOf:
                                        - type: string
                                          enum:
                                            - TEXT_CONTAINS
                                        - type: string
                                          enum:
                                            - TEXT_DOES_NOT_CONTAIN
                                        - type: string
                                          enum:
                                            - TEXT_EXACTLY_MATCHES
                                        - type: string
                                          enum:
                                            - TEXT_DOES_NOT_EXACTLY_MATCH
                                        - type: string
                                          enum:
                                            - TEXT_START_WITH
                                        - type: string
                                          enum:
                                            - TEXT_DOES_NOT_START_WITH
                                        - type: string
                                          enum:
                                            - TEXT_ENDS_WITH
                                        - type: string
                                          enum:
                                            - TEXT_DOES_NOT_END_WITH
                                        - type: string
                                          enum:
                                            - LIST_CONTAINS
                                        - type: string
                                          enum:
                                            - LIST_DOES_NOT_CONTAIN
                                  required:
                                    - firstValue
                                    - secondValue
                                - type: object
                                  properties:
                                    firstValue:
                                      type: string
                                    secondValue:
                                      type: string
                                    operator:
                                      anyOf:
                                        - type: string
                                          enum:
                                            - NUMBER_IS_GREATER_THAN
                                        - type: string
                                          enum:
                                            - NUMBER_IS_LESS_THAN
                                        - type: string
                                          enum:
                                            - NUMBER_IS_EQUAL_TO
                                  required:
                                    - firstValue
                                    - secondValue
                                - type: object
                                  properties:
                                    firstValue:
                                      type: string
                                    secondValue:
                                      type: string
                                    operator:
                                      anyOf:
                                        - type: string
                                          enum:
                                            - DATE_IS_BEFORE
                                        - type: string
                                          enum:
                                            - DATE_IS_EQUAL
                                        - type: string
                                          enum:
                                            - DATE_IS_AFTER
                                  required:
                                    - firstValue
                                    - secondValue
                                - type: object
                                  properties:
                                    firstValue:
                                      type: string
                                    operator:
                                      anyOf:
                                        - type: string
                                          enum:
                                            - EXISTS
                                        - type: string
                                          enum:
                                            - DOES_NOT_EXIST
                                        - type: string
                                          enum:
                                            - BOOLEAN_IS_TRUE
                                        - type: string
                                          enum:
                                            - BOOLEAN_IS_FALSE
                                        - type: string
                                          enum:
                                            - LIST_IS_EMPTY
                                        - type: string
                                          enum:
                                            - LIST_IS_NOT_EMPTY
                                  required:
                                    - firstValue
                        branchName:
                          type: string
                      required:
                        - branchIndex
                        - stepName
                        - branchName
                  required:
                    - type
                    - request
                  description: Add Branch
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - DUPLICATE_BRANCH
                    request:
                      type: object
                      properties:
                        branchIndex:
                          type: number
                        stepName:
                          type: string
                      required:
                        - branchIndex
                        - stepName
                  required:
                    - type
                    - request
                  description: Duplicate Branch
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - SET_SKIP_ACTION
                    request:
                      type: object
                      properties:
                        names:
                          type: array
                          items:
                            type: string
                        skip:
                          type: boolean
                      required:
                        - names
                        - skip
                  required:
                    - type
                    - request
                  description: Skip Action
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - UPDATE_METADATA
                    request:
                      type: object
                      properties:
                        metadata:
                          anyOf:
                            - type: object
                              propertyNames:
                                type: string
                              additionalProperties: {}
                            - type: 'null'
                  required:
                    - type
                    - request
                  description: Update Metadata
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - MOVE_BRANCH
                    request:
                      type: object
                      properties:
                        sourceBranchIndex:
                          type: number
                        targetBranchIndex:
                          type: number
                        stepName:
                          type: string
                      required:
                        - sourceBranchIndex
                        - targetBranchIndex
                        - stepName
                  required:
                    - type
                    - request
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - SAVE_SAMPLE_DATA
                    request:
                      type: object
                      properties:
                        stepName:
                          type: string
                        payload: {}
                        type:
                          type: string
                          enum:
                            - INPUT
                            - OUTPUT
                      required:
                        - stepName
                        - payload
                        - type
                  required:
                    - type
                    - request
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - UPDATE_MINUTES_SAVED
                    request:
                      type: object
                      properties:
                        timeSavedPerRun:
                          anyOf:
                            - type: number
                            - type: 'null'
                  required:
                    - type
                    - request
                  description: Update Minutes Saved
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - UPDATE_OWNER
                    request:
                      type: object
                      properties:
                        ownerId:
                          type: string
                      required:
                        - ownerId
                  required:
                    - type
                    - request
                  description: Update Owner
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - UPDATE_NOTE
                    request:
                      type: object
                      properties:
                        id:
                          type: string
                        content:
                          type: string
                        ownerId:
                          anyOf:
                            - type: string
                            - type: 'null'
                        color:
                          type: string
                          enum:
                            - orange
                            - red
                            - green
                            - blue
                            - purple
                            - yellow
                        position:
                          type: object
                          properties:
                            x:
                              type: number
                            'y':
                              type: number
                          required:
                            - x
                            - 'y'
                        size:
                          type: object
                          properties:
                            width:
                              type: number
                            height:
                              type: number
                          required:
                            - width
                            - height
                      required:
                        - id
                        - content
                        - color
                        - position
                        - size
                  required:
                    - type
                    - request
                  description: Update Note
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - DELETE_NOTE
                    request:
                      type: object
                      properties:
                        id:
                          type: string
                      required:
                        - id
                  required:
                    - type
                    - request
                  description: Delete Note
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - ADD_NOTE
                    request:
                      type: object
                      properties:
                        id:
                          type: string
                        content:
                          type: string
                        color:
                          type: string
                          enum:
                            - orange
                            - red
                            - green
                            - blue
                            - purple
                            - yellow
                        position:
                          type: object
                          properties:
                            x:
                              type: number
                            'y':
                              type: number
                          required:
                            - x
                            - 'y'
                        size:
                          type: object
                          properties:
                            width:
                              type: number
                            height:
                              type: number
                          required:
                            - width
                            - height
                      required:
                        - id
                        - content
                        - color
                        - position
                        - size
                  required:
                    - type
                    - request
                  description: Add Note
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - UPDATE_SAMPLE_DATA_INFO
                    request:
                      type: object
                      properties:
                        stepName:
                          type: string
                        sampleDataSettings:
                          anyOf:
                            - type: object
                              properties:
                                sampleDataFileId:
                                  type: string
                                sampleDataInputFileId:
                                  type: string
                            - type: 'null'
                      required:
                        - stepName
                  required:
                    - type
                    - request
                  description: Update Sample Data Info
      responses:
        '200':
          description: Default Response
      security:
        - apiKey: []
components:
  securitySchemes:
    apiKey:
      type: http
      description: Use your api key generated from the admin console
      scheme: bearer

````